import mongoose from 'mongoose';
import SampleModel from './sample';
import MeasurementTemplateModel from './measurement_template';
import db from '../db';



const MeasurementSchema = new mongoose.Schema({
  sample_id: {type: mongoose.Schema.Types.ObjectId, ref: SampleModel},
  values: mongoose.Schema.Types.Mixed,
  measurement_template: {type: mongoose.Schema.Types.ObjectId, ref: MeasurementTemplateModel},
  status: Number
}, {minimize: false});

// changelog query helper
MeasurementSchema.query.log = function <Q extends mongoose.DocumentQuery<any, any>> (req) {
  db.log(req, this);
  return this;
}

export default mongoose.model<any, mongoose.Model<any, any>>('measurement', MeasurementSchema);